<!DOCTYPE html>
<html lang="EN">

<head>
  <meta charset="utf-8">
  <title>IPF Report</title>
</head>

<body>
  {% set snapshot1 = client(snapshot_id="$last") %}
  {% set snapshot2 = client(snapshot_id="$prev") %}

  <!-- First page content -->
  <br><br>
  <div class="logo">
    <img alt="IP Fabric logo" src="{{ logo_url }}" />
  </div>
  <div class="main-title">
    <h1>DATA REPORT</h1>
  </div>

  <!-- Second page content -->
  <div class="container">
    <div class="section-1">
      <div class="icon-container">
        <div class="section-title"> IP Fabric Data Overview</div>
      </div>
      <div>
        The IP Fabric data report presents a comprehensive network infrastructure analysis, providing detailed insights
        into various sections such as network inventory, interfaces, addressing, switching, routing, and wireless
        technologies.
        <br><br>
        The report is generated based on two snapshots, showcasing the values of the first snapshot and the delta value
        (+/-) compared to the second snapshot. This approach allows network engineers and administrators to track the
        changes and improvements made to the network over time.
      </div>
    </div>
    <div class="main-title-container">
      <div class="numbers">1</div>
      <h2 class="main-titles">Network data summary</h2>
    </div>
    <table>
      <tr>
        <th>IP Fabric url</th>
        <td>{{ snapshot1.hostname }}</td>
      </tr>
      <tr>
        <th>IP Fabric Version</th>
        <td>{{ snapshot1.os_version }}</td>
      </tr>
      <tr>
        <th>Snapshot Name #1</th>
        <td>{{ snapshot1.snapshot.name }}</td>
      </tr>
      <tr>
        <th>Snapshot ID #1</th>
        <td>{{ snapshot1.snapshot.snapshot_id }}</td>
      </tr>
      <tr>
        <th>Snapshot Name #2</th>
        <td>{{ snapshot2.name }}</td>
      </tr>
      <tr>
        <th>Snapshot ID #2</th>
        <td>{{ snapshot2.snapshot_id }}</td>
      </tr>
      <tr>
        <th>Network sites/groups</th>
        <td>{{ snapshot1.inventory.sites.count() }} ({{ delta(snapshot1.inventory.sites.count(),
          snapshot2.inventory.sites.count())}})</td>
      </tr>
    </table>
    <div class="main-title-container">
      <div class="numbers">2</div>
      <h2 class="main-titles">Network vendors</h2>
    </div>
    <div class="section-2">
      <div>
        This report provides key statistical data on network vendors in two snapshots, showing the number of devices by
        vendor and the changes in the number of devices over time.
      </div>
      <table class="table-spacing">
        <thead>
          <tr>
            <th class="table-cell-width-even">Vendor</th>
            <th class="table-cell-width-even">Devices count</th>
          </tr>
        </thead>
        <tbody>
          {% set vendors_prev = create_dict(snapshot2.inventory.vendors.all(), "vendor") %}
          {% set vendors = snapshot1.inventory.vendors.all() %}
          {% for vendor in vendors %}
          <tr>
            <td class="table-cell-width">{{ vendor.vendor }}</td>
            {% if vendors_prev.get(vendor.vendor) %}
            <td class="table-cell-width">{{ vendor.devicesCount }} ({{ vendor.devicesCount -
              vendors_prev[vendor.vendor].devicesCount }})</td>
            {% else %}
            <td class="table-cell-width">{{ vendor.devicesCount }}</td>
            {% endif %}
          </tr>
          {% endfor %}
        </tbody>
        <thead>
          <tr>
            <th class="table-cell-width-even">Models count</th>
            <th class="table-cell-width-even">Platforms count</th>
            <th class="table-cell-width-even">Families count</th>
          </tr>
        </thead>
        <tbody class="table-spacing">
          {% for vendor in vendors %}
          <tr>
            {% if vendors_prev.get(vendor.vendor, None) %}
            <td class="table-cell-width">{{ vendor.modelsCount }} ({{ vendor.modelsCount -
              vendors_prev[vendor.vendor].modelsCount }})</td>
            <td class="table-cell-width">{{ vendor.platformsCount }} ({{ vendor.platformsCount -
              vendors_prev[vendor.vendor].platformsCount }})</td>
            <td class="table-cell-width">{{ vendor.familiesCount }} ({{ vendor.familiesCount -
              vendors_prev[vendor.vendor].familiesCount }})</td>
            {% else %}
            <td class="table-cell-width">{{ vendor.modelsCount }}</td>
            <td class="table-cell-width">{{ vendor.platformsCount }}</td>
            <td class="table-cell-width">{{ vendor.familiesCount }}</td>
            {% endif %}
          </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
    <div class="main-title-container">
      <div class="numbers">3</div>
      <h2 class="main-titles">Interfaces overview</h2>
    </div>
    <div class="section-3">
      The Interfaces overview section provides insights into the network interfaces of the infrastructure. It reports on
      the total number of active interfaces, the number of edge interfaces, and the number of switchport interfaces. It
      also includes information on channel interfaces and the number of IPv4 and IPv6 tunnel interfaces. Finally, it
      provides details on the number of IPsec tunnels and gateways. The delta values indicate changes between two
      snapshots, highlighting any new or removed interfaces in the network.
    </div>
    <table>
      <tr>
        <th>Network interfaces</th>
        <td>{{ snapshot1.snapshot.interface_count }} ({{ delta(snapshot1.snapshot.interface_count,
          snapshot2.snapshot.interface_count)}})</td>
      </tr>
      <tr>
        <th>Active interfaces</th>
        <td>{{ snapshot1.snapshot.interface_active_count }} ({{ delta(snapshot1.snapshot.interface_active_count,
          snapshot2.snapshot.interface_active_count) }})</td>
      </tr>
      <tr>
        <th>Edge interfaces</th>
        <td>{{ snapshot1.snapshot.interface_edge_count }} ({{ delta(snapshot1.snapshot.interface_edge_count,
          snapshot2.snapshot.interface_edge_count)}})</td>
      </tr>
      <tr>
        <th>Switchport interfaces</th>
        <td>{{ snapshot1.technology.interfaces.switchport.count() }} ({{
          delta(snapshot1.technology.interfaces.switchport.count(), snapshot2.technology.interfaces.switchport.count())
          }})</td>
      </tr>
      <tr>
        <th>Channel interfaces</th>
        <td>{{ snapshot1.technology.port_channels.member_status_table.count() }} ({{
          delta(snapshot1.technology.port_channels.member_status_table.count(),
          snapshot2.technology.port_channels.member_status_table.count()) }})</td>
      </tr>
      <tr>
        <th>IPv4 Tunnel interfaces</th>
        <td>{{ snapshot1.technology.interfaces.tunnels_ipv4.count() }} ({{
          delta(snapshot1.technology.interfaces.tunnels_ipv4.count(),
          snapshot2.technology.interfaces.tunnels_ipv4.count()) }})</td>
      </tr>
      <tr>
        <th>IPv6 Tunnel interfaces</th>
        <td>{{ snapshot1.technology.interfaces.tunnels_ipv6.count() }} ({{
          delta(snapshot1.technology.interfaces.tunnels_ipv6.count(),
          snapshot2.technology.interfaces.tunnels_ipv6.count()) }})</td>
      </tr>
      <tr>
        <th>IPsec Gateways</th>
        <td>{{ snapshot1.technology.security.ipsec_gateways.count() }} ({{
          delta(snapshot1.technology.security.ipsec_gateways.count(),
          snapshot2.technology.security.ipsec_gateways.count()) }})</td>
      </tr>
      <tr>
        <th>IPsec tunnels</th>
        <td>{{ snapshot1.technology.security.ipsec_tunnels.count() }} ({{
          delta(snapshot1.technology.security.ipsec_tunnels.count(),
          snapshot2.technology.security.ipsec_tunnels.count()) }})</td>
      </tr>
    </table>
    <div class="main-title-container">
      <div class="numbers">4</div>
      <h2 class="main-titles">Addressing overview</h2>
    </div>
    <div class="section-4">
      The Addressing Overview section provides a detailed summary of the network addressing aspects based on two
      snapshots. It presents statistical data on managed networks, IPv4 and IPv6 interfaces, Address Resolution Protocol
      (ARP) tables, and Virtual Route Forwarding (VRF) instances. The first number indicates the current value, and the
      second number represents the change between two snapshots. This section provides valuable insights into the growth
      and changes in network addressing over time.
    </div>
    <table>
      <tr>
        <th>Managed networks</th>
        <td>{{ snapshot1.technology.managed_networks.networks.count() }} ({{
          delta(snapshot1.technology.managed_networks.networks.count(),
          snapshot2.technology.managed_networks.networks.count()) }})</td>
      </tr>
      <tr>
        <th>VRFs</th>
        <td>{{ snapshot1.technology.routing.vrf_summary.count()}} ({{
          delta(snapshot1.technology.routing.vrf_summary.count(), snapshot2.technology.routing.vrf_summary.count())}})
        </td>
      </tr>
      <tr>
        <th>IPv4 interfaces</th>
        <td>{{ snapshot1.technology.addressing.managed_ip_ipv4.count() }} ({{
          delta(snapshot1.technology.addressing.managed_ip_ipv4.count(),
          snapshot2.technology.addressing.managed_ip_ipv4.count() )}})</td>
      </tr>
      <tr>
        <th>IPv6 interfaces</th>
        <td>{{ snapshot1.technology.addressing.managed_ip_ipv6.count() }} ({{
          delta(snapshot1.technology.addressing.managed_ip_ipv6.count(),
          snapshot2.technology.addressing.managed_ip_ipv6.count()) }})</td>
      </tr>
      <tr>
        <th>ARP entries</th>
        <td>{{ snapshot1.technology.addressing.arp_table.count() }} ({{
          delta(snapshot1.technology.addressing.arp_table.count(), snapshot2.technology.addressing.arp_table.count())
          }})</td>
      </tr>
      <tr>
        <th>MAC entries</th>
        <td>{{ snapshot1.technology.addressing.mac_table.count() }} ({{
          delta(snapshot1.technology.addressing.mac_table.count(), snapshot2.technology.addressing.mac_table.count())
          }})</td>
      </tr>
    </table>
    <div class="main-title-container">
      <div class="numbers">5</div>
      <h2 class="main-titles">Switching overview</h2>
    </div>
    <div class="section-5">
      The Switching overview section provides key statistics on the status of network switching components. These
      include
      data on MAC addresses, VLANs, and Spanning Tree Protocol (STP) instances, bridges, virtual ports, and neighbors.
      The
      data is presented in two numbers: the first value represents the initial snapshot, and the second value (+X)
      represents the difference between the current snapshot and the previous one.
    </div>
    <table>
      <tr>
        <th>MAC entries</th>
        <td>{{ snapshot1.technology.addressing.mac_table.count() }} ({{
          delta(snapshot1.technology.addressing.mac_table.count(), snapshot2.technology.addressing.mac_table.count())
          }})</td>
      </tr>
      <tr>
        <th>VLANs</th>
        <td>{{ snapshot1.technology.vlans.network_summary.count() }} ({{
          delta(snapshot1.technology.vlans.network_summary.count(), snapshot2.technology.vlans.network_summary.count())
          }})</td>
      </tr>
      <tr>
        <th>STP VLANs</th>
        <td>{{ snapshot1.technology.stp.vlans.count() }} ({{ delta(snapshot1.technology.stp.vlans.count(),
          snapshot2.technology.stp.vlans.count() )}})</td>
      </tr>
      <tr>
        <th>STP Bridges</th>
        <td>{{ snapshot1.technology.stp.bridges.count() }} ({{ delta(snapshot1.technology.stp.bridges.count(),
          snapshot2.technology.stp.bridges.count() )}})</td>
      </tr>
      <tr>
        <th>STP Virtual Ports</th>
        <td>{{ snapshot1.technology.stp.ports.count() }} ({{ delta(snapshot1.technology.stp.ports.count(),
          snapshot2.technology.stp.ports.count() )}})</td>
      </tr>
      <tr>
        <th>STP Instances</th>
        <td>{{ snapshot1.technology.stp.instances.count() }} ({{ delta(snapshot1.technology.stp.instances.count(),
          snapshot2.technology.stp.instances.count() )}})</td>
      </tr>
      <tr>
        <th>STP Neighbors</th>
        <td>{{ snapshot1.technology.stp.neighbors.count() }} ({{ delta(snapshot1.technology.stp.neighbors.count(),
          snapshot2.technology.stp.neighbors.count())}})</td>
      </tr>
    </table>
    <div class="main-title-container">
      <div class="numbers">6</div>
      <h2 class="main-titles">Routing overview</h2>
    </div>
    <div class="section-6">
      The Routing overview section provides statistical data on the number of IPv4 and IPv6 routes, as well as the
      number
      of routes per protocol, including Connected, Static, BGP, OSPF, IS-IS, EIGRP, and RIP. Additionally, the report
      shows changes between two snapshots, including the number of added or removed routes for each protocol. This
      information allows network administrators to quickly understand the changes that have occurred in their network's
      routing tables.
    </div>
    <table>
      <tr>
        <th>IPv4 routes</th>
        <td>{{ snapshot1.technology.routing.routes_ipv4.count() }} ({{
          delta(snapshot1.technology.routing.routes_ipv4.count(), snapshot2.technology.routing.routes_ipv4.count()) }})
        </td>
      </tr>
      <tr>
        <th>IPv6 routes</th>
        <td>{{ snapshot1.technology.routing.routes_ipv6.count() }} ({{
          delta(snapshot1.technology.routing.routes_ipv6.count(), snapshot2.technology.routing.routes_ipv6.count()) }})
        </td>
      </tr>
      <tr>
        <th>Multicast routes</th>
        <td>{{ snapshot1.technology.multicast.mroute_table.count() }} ({{
          delta(snapshot1.technology.multicast.mroute_table.count(),
          snapshot2.technology.multicast.mroute_table.count()) }})</td>
      </tr>
      <tr>
        <th>Attached routes</th>
        <td>{{ snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "A"]}) }} ({{
          delta(snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "A"]}),
          snapshot2.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "A"]})) }})</td>
      </tr>
      <tr>
        <th>BGP routes</th>
        <td>{{ snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "B"]}) }} ({{
          delta(snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "B"]}),
          snapshot2.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "B"]})) }})</td>
      </tr>
      <tr>
        <th>Connected routes</th>
        <td>{{ snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "C"]}) }} ({{
          delta(snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "C"]}),
          snapshot2.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "C"]})) }})</td>
      <tr>
        <th>EIGRP routes</th>
        <td>{{ snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "D"]}) }} ({{
          delta(snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "D"]}),
          snapshot2.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "D"]})) }})</td>
      </tr>
      <tr>
        <th>ISIS routes</th>
        <td>{{ snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "IS-IS"]}) }} ({{
          delta(snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "IS-IS"]}),
          snapshot2.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "IS-IS"]})) }})</td>
      </tr>
      <tr>
        <th>OSPF routes</th>
        <td>{{ snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "O"]}) }} ({{
          delta(snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "O"]}),
          snapshot2.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "O"]})) }})</td>
      </tr>
      <tr>
        <th>RIP routes</th>
        <td>{{ snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "R"]}) }} ({{
          delta(snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "R"]}),
          snapshot2.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "R"]})) }})</td>
      </tr>
      <tr>
        <th>Static routes</th>
        <td>{{ snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "S"]}) }} ({{
          delta(snapshot1.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "S"]}),
          snapshot2.technology.routing.routes_ipv4.count(filters={"protocol": ["eq", "S"]})) }})</td>
      </tr>
    </table>
  </div>
</body>

</html>
